local _, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then
    return
end

local RuneMover = CreateFrame("frame")

local RUNETYPE_BLOOD = 1;
local RUNETYPE_UNHOLY = 3;
local RUNETYPE_FROST = 2;
local RUNETYPE_DEATH = 4;

local iconTextures = {};

local runes = {};
local tex = {};
local border = {};
local cooldown = {};
local hide = true
local runica = false
local overlay = {}
local first = true
for i = 1, 6 do 
    runes[i] = _G["RuneButtonIndividual"..i]
    tex[i] = _G["RuneButtonIndividual"..i.."Rune"]
    border[i] = _G["RuneButtonIndividual"..i.."Border"]
    cooldown[i] = _G["RuneButtonIndividual"..i.."Cooldown"]
    cooldown[i]:HookScript("OnShow", function(self) if hide then self:Hide() end end)
    runes[i]:SetClampedToScreen(true)
    runes[i]:SetFrameStrata("MEDIUM")
    runes[i]:EnableMouse(false)
end

function RuneMover_OnLoad(self)
    self:SetScript("OnEvent", RuneMover_OnEvent)
    self:RegisterEvent("PLAYER_REGEN_DISABLED");
    self:RegisterEvent("PLAYER_REGEN_ENABLED");
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    self:RegisterEvent("UNIT_ENTERED_VEHICLE");
    self:RegisterEvent("UNIT_EXITED_VEHICLE");
    self:RegisterEvent("RUNE_POWER_UPDATE");
    self:RegisterEvent("RUNE_TYPE_UPDATE");
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    imagetimer = 4
    RuneMover:SetScript("OnUpdate", RuneMover_ImagesOnUpdate)
end

function RuneMover_OnEvent(self, event, ...)
    if (event == "PLAYER_REGEN_DISABLED") then
        RuneFrame:SetAlpha(RMDB.alphain)
    elseif (event == "PLAYER_REGEN_ENABLED") then
        RuneFrame:SetAlpha(RMDB.alphaout)
    elseif (event == "PLAYER_ENTERING_WORLD") then
        RuneFrame:SetAlpha(RMDB.alphaout)
        RuneMover_Images();
    elseif (event == "UNIT_EXITED_VEHICLE") and (... == "player") then
        timer = 4
        RuneMover:SetScript("OnUpdate", RuneMover_OnUpdate)
    elseif (event == "UNIT_ENTERED_VEHICLE") and (... == "player") then
        RuneFrame:Hide()
    elseif (event == "RUNE_TYPE_UPDATE") then
        local rune = ...;
        Button_Update(rune);
    elseif (event == "RUNE_POWER_UPDATE") then
        local rune, usable = ...;
        if rune == 3 then
            rune = 5
        elseif rune == 5 then
            rune = 3
        elseif rune == 4 then
            rune = 6
        elseif rune == 6 then
            rune = 4
        end
        if not rune or rune > 6 or rune < 1 then
            return
        elseif not usable and not (RMDB.images == "0" or RMDB.images == "7") then
            tex[rune]:SetVertexColor(0.4,0.4,0.4,0.9);
        elseif usable and not (RMDB.images == "0" or RMDB.images == "7") then
            tex[rune]:SetVertexColor(1,1,1,1);
        end
    elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
        local eventtype = select(2, ...)
        if (eventtype == "UNIT_DIED") then
            local name = select(4, ...)
            if (name == UnitName("player")) then
                RuneMover_Images();
            end
        end
    end
end

function RuneMover_Orientation(newValue) 
    RuneMover_Clear();
    if newValue == "1" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("BOTTOM", runes[1], "BOTTOM", 0, -22)
        runes[3]:SetPoint("BOTTOM", runes[2], "BOTTOM", 0, -22)
        runes[4]:SetPoint("BOTTOM", runes[3], "BOTTOM", 0, -22)
        runes[5]:SetPoint("BOTTOM", runes[4], "BOTTOM", 0, -22)
        runes[6]:SetPoint("BOTTOM", runes[5], "BOTTOM", 0, -22)
    elseif newValue == "0" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 4, 0)
        runes[3]:SetPoint("LEFT", runes[2], "RIGHT", 4, 0)
        runes[4]:SetPoint("LEFT", runes[3], "RIGHT", 4, 0)
        runes[5]:SetPoint("LEFT", runes[4], "RIGHT", 4, 0)
        runes[6]:SetPoint("LEFT", runes[5], "RIGHT", 4, 0)
    elseif newValue == "2" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 4, 0)
        runes[3]:SetPoint("BOTTOM", runes[1], "BOTTOM", 0, -22)
        runes[4]:SetPoint("BOTTOM", runes[2], "BOTTOM", 0, -22)
        runes[5]:SetPoint("BOTTOM", runes[3], "BOTTOM", 0, -22)
        runes[6]:SetPoint("BOTTOM", runes[4], "BOTTOM", 0, -22)
    elseif newValue == "3" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 6, 26)
        runes[3]:SetPoint("LEFT", runes[1], "RIGHT", 40, 36)
        runes[4]:SetPoint("LEFT", runes[3], "RIGHT", 12, 0)
        runes[5]:SetPoint("LEFT", runes[1], "RIGHT", 102, 26)
        runes[6]:SetPoint("LEFT", runes[1], "RIGHT", 125, 0)
    elseif newValue == "4" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("BOTTOM", runes[1], "BOTTOM", 0, -22)
        runes[3]:SetPoint("LEFT", runes[1], "RIGHT", 4, 0)
        runes[4]:SetPoint("LEFT", runes[2], "RIGHT", 4, 0)
        runes[5]:SetPoint("LEFT", runes[3], "RIGHT", 4, 0)
        runes[6]:SetPoint("LEFT", runes[4], "RIGHT", 4, 0)
    elseif newValue == "5" then
        runes[1]:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", RMDB.x, RMDB.y)
        runes[2]:SetPoint("LEFT", runes[1], "RIGHT", 6, -26)
        runes[3]:SetPoint("LEFT", runes[1], "RIGHT", 40, -36)
        runes[4]:SetPoint("LEFT", runes[3], "RIGHT", 12, 0)
        runes[5]:SetPoint("LEFT", runes[1], "RIGHT", 102, -26)
        runes[6]:SetPoint("LEFT", runes[1], "RIGHT", 125, 0)
    end
end

function RuneMover_Images(newValue)
    if newValue == "1" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\beta\\blood.blp";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\beta\\unholy.blp";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\beta\\frost.blp";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\beta\\death.blp";
    elseif newValue == "0" then
        hide = false
        for i = 1, 6 do
            border[i]:Show()
            cooldown[i]:Show()
            if runica == true then
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
                cooldown[i]:SetWidth(18)
                cooldown[i]:SetHeight(18)
                overlay[i]:SetTexture(nil)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood.blp";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy.blp";
        iconTextures[RUNETYPE_FROST] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost.blp";
        iconTextures[RUNETYPE_DEATH] = "Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death.blp";
    elseif newValue == "2" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\DKI\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\DKI\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\DKI\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\DKI\\death.tga";
    elseif newValue == "3" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\letter\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\letter\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\letter\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\letter\\death.tga";
    elseif newValue == "4" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\orb\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\orb\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\orb\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\orb\\death.tga";
    elseif newValue == "5" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\beta-enhanced\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\beta-enhanced\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\beta-enhanced\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\beta-enhanced\\death.tga";
    elseif newValue == "6" then
        hide = true
        for i = 1, 6 do
            border[i]:Hide()
            if runica == true then
                overlay[i]:SetTexture(nil)
                tex[i]:SetTexCoord(0,1,0,1)
                runes[i]:SetHeight(18)
                runes[i]:SetWidth(18)
            end
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\japanese\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\japanese\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\japanese\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\japanese\\death.tga";
    elseif newValue == "7" then
        hide = false
        runica = true
        for i = 1, 6 do
            tex[i]:SetTexCoord(0.1,0.9,0.1,0.9)
            border[i]:Hide();
            runes[i]:SetHeight(21)
            runes[i]:SetWidth(21)
            cooldown[i]:Show();
            cooldown[i]:SetWidth(22)
            cooldown[i]:SetHeight(22)
            overlay[i] = runes[i]:CreateTexture("RuneButtonIndividual"..i.."Overlay", "OVERLAY")
            overlay[i]:SetTexture("Interface\\AddOns\\RuneMover\\images\\runica\\border.tga")
            overlay[i]:SetAllPoints(tex[i])
        end
        iconTextures[RUNETYPE_BLOOD] = "Interface\\AddOns\\RuneMover\\images\\runica\\blood.tga";
        iconTextures[RUNETYPE_UNHOLY] = "Interface\\AddOns\\RuneMover\\images\\runica\\unholy.tga";
        iconTextures[RUNETYPE_FROST] = "Interface\\AddOns\\RuneMover\\images\\runica\\frost.tga";
        iconTextures[RUNETYPE_DEATH] = "Interface\\AddOns\\RuneMover\\images\\runica\\death.tga";
    end
    tex[1]:SetTexture(iconTextures[1])
    tex[2]:SetTexture(iconTextures[1])
    tex[3]:SetTexture(iconTextures[2])
    tex[4]:SetTexture(iconTextures[2])
    tex[5]:SetTexture(iconTextures[3])
    tex[6]:SetTexture(iconTextures[3])
end

function RuneMover_Clear()
    for i = 1, 6 do
        runes[i]:ClearAllPoints()
    end
end

function Button_Update(rune)
    local runeType = GetRuneType(rune);
    
    if (rune ~= 7 and rune ~= 8) then
        if (runeType) then
            tex[rune]:Show()
            tex[rune]:SetTexture(iconTextures[runeType])
        else
            tex[rune]:Hide()
        end
    end
end

local timer = 0
function RuneMover_OnUpdate(self, elapsed)
    timer = timer - elapsed
    RuneMover_Clear();
    
    if timer < 0 then
        RuneFrame:Show();
        RuneMover_Orientation();
        self:SetScript("OnUpdate", nil)
    end
end

local imagetimer = 0
function RuneMover_ImagesOnUpdate(self, elapsed)
    imagetimer = imagetimer - elapsed
    
    if imagetimer < 0 then
        RuneMover_Images();
        self:SetScript("OnUpdate", nil)
    end
end

local font = RuneMover:CreateFontString("font", "ARTWORK", "GameFontNormal")
function RuneMover_Lock(newValue)
    if newValue == "1" then
        font:SetText("|cffffffffX|r")
        font:SetPoint("CENTER", runes[1])
        font:Show();
        runes[1]:EnableMouse(true)
        runes[1]:SetMovable(true)
        runes[1]:RegisterForDrag("LeftButton")
        runes[1]:SetScript("OnDragStart", function() runes[1]:StartMoving() end)
        runes[1]:SetScript("OnDragStop", function() runes[1]:StopMovingOrSizing();
        RMDB.x, RMDB.y = runes[1]:GetLeft(), runes[1]:GetBottom() end)
    elseif newValue == "0" then
        font:Hide();
        runes[1]:EnableMouse(false)
        runes[1]:SetMovable(false)
    end
end

function Slider_ValueChanged(newValue)
    for i = 1, 6 do
        runes[i]:SetScale(newValue)
    end
end

function Alphaout_ValueChanged(newValue)
    RuneFrame:SetAlpha(newValue)
end

SlashCmdList["RUNEMOVER"] = function(msg)
        RuneMover_SlashHandler(string.lower(msg));
end

SLASH_RUNEMOVER1 = "/runemover"
SLASH_RUNEMOVER2 = "/rm"

function RuneMover_SlashHandler(msg)
    local frame = LibStub("Portfolio").GetOptionsFrame("RuneMover")
    InterfaceOptionsFrame_OpenToCategory(frame)
end

RuneMover_OnLoad(RuneMover)